---
title: contain
slug: Web/CSS/contain
tags:
  - CSS
  - CSS Containment
  - CSS Property
  - Layout
  - NeedsExample
  - Paint
  - Reference
  - Style
  - Web
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>contain</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property allows an author to indicate that an element and its contents are, as much as possible, <em>independent</em> of the rest of the document tree. This allows the browser to recalculate layout, style, paint, size, or any combination of them for a limited area of the DOM and not the entire page, leading to obvious performance benefits.</p>

<p>This property is useful on pages that contain a lot of widgets that are all independent, as it can be used to prevent each widget's internals from having side effects outside of the widget's bounding-box.</p>

<div class="notecard note">
<p><strong>Note:</strong> If applied (with value: <code>paint</code>, <code>strict</code> or <code>content</code>), this property creates:</p>

<ol>
 <li>A new <a href="/en-US/docs/Web/CSS/Containing_block">containing block</a> (for the descendants whose {{cssxref("position")}} property is <code>absolute</code> or <code>fixed</code>).</li>
 <li>A new <a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context">stacking context</a>.</li>
 <li>A new <a href="/en-US/docs/Web/Guide/CSS/Block_formatting_context">block formatting context</a>.</li>
</ol>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
contain: none;
contain: strict;
contain: content;
contain: size;
contain: layout;
contain: style;
contain: paint;

/* Multiple keywords */
contain: size paint;
contain: size layout paint;

/* Global values */
contain: inherit;
contain: initial;
contain: unset;</pre>

<p>The <code>contain</code> property is specified as either one of the following:</p>

<ul>
 <li>Using a single <code>none</code>, <code>strict</code>, or <code>content</code> keyword.</li>
 <li>Using one or more of the <code>size</code>, <code>layout</code>, <code>style</code>, and <code>paint</code> keywords in any order.</li>
</ul>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>none</code></dt>
 <dd>Indicates the element renders as normal, with no containment applied.</dd>
 <dt><code>strict</code></dt>
 <dd>Indicates that all containment rules except <code>style</code> are applied to the element. This is equivalent to <code>contain: size layout paint</code>.</dd>
 <dt><code>content</code></dt>
 <dd>Indicates that all containment rules except <code>size</code> and <code>style</code> are applied to the element. This is equivalent to <code>contain: layout paint</code>.</dd>
 <dt><code>size</code></dt>
 <dd>Indicates that the element can be sized without the need to examine its descendants' sizes.</dd>
 <dt><code>layout</code></dt>
 <dd>Indicates that nothing outside the element may affect its internal layout and vice versa.</dd>
 <dt><code>style</code></dt>
 <dd>Indicates that, for properties that can have effects on more than just an element and its descendants, those effects don't escape the containing element. Note that this value is marked "at-risk" in the spec and may not be supported everywhere.</dd>
 <dt><code>paint</code></dt>
 <dd>Indicates that descendants of the element don't display outside its bounds. If the containing box is offscreen, the browser does not need to paint its contained elements — these must also be offscreen as they are contained completely by that box. And if a descendant overflows the containing element's bounds, then that descendant will be clipped to the containing element's border-box.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_layout">Simple layout</h3>

<p>The markup below consists of a number of articles, each with content:</p>

<pre class="brush: html notranslate">&lt;h1&gt;My blog&lt;/h1&gt;
&lt;article&gt;
  &lt;h2&gt;Heading of a nice article&lt;/h2&gt;
  &lt;p&gt;Content here.&lt;/p&gt;
&lt;/article&gt;
&lt;article&gt;
  &lt;h2&gt;Another heading of another article&lt;/h2&gt;
  &lt;img src="graphic.jpg" alt="photo"&gt;
  &lt;p&gt;More content here.&lt;/p&gt;
&lt;/article&gt;</pre>

<p>Each <code>&lt;article&gt;</code> and <code>&lt;img&gt;</code> is given a border, and the images are floated:</p>

<pre class="brush: css notranslate">img {
  float: left;
  border: 3px solid black;
}

article {
  border: 1px solid black;
}</pre>

<p>{{EmbedGHLiveSample("css-examples/contain/simple-layout.html", '100%', 400)}}</p>

<p>You can immediately see an issue — no effort is made to clear the floating beyond the bottom of the article.</p>

<h3 id="Float_interference">Float interference</h3>

<p>If we were to insert another image at the bottom of the first article, a large portion of the DOM tree may be re-laid out or repainted, and this would interfere further with the layout of the second article:</p>

<pre class="brush: html notranslate">&lt;h1&gt;My blog&lt;/h1&gt;
&lt;article&gt;
  &lt;h2&gt;Heading of a nice article&lt;/h2&gt;
  &lt;p&gt;Content here.&lt;/p&gt;
  &lt;img src="i-just-showed-up.jpg" alt="social"&gt;
&lt;/article&gt;
&lt;article&gt;
  &lt;h2&gt;Another heading of another article&lt;/h2&gt;
  &lt;img src="graphic.jpg" alt="photo"&gt;
  &lt;p&gt;More content here.&lt;/p&gt;
&lt;/article&gt;</pre>

<div class="hidden">
<pre class="brush: css notranslate">img {
  float: left;
  border: 3px solid black;
}

article {
  border: 1px solid black;
}</pre>
</div>

<p>As you can see, because of the way floats work, the first image ends up inside the area of the second article:</p>

<p>{{EmbedGHLiveSample("css-examples/contain/float-interference.html", '100%', 400)}}</p>

<h3 id="Fixing_with_contain">Fixing with contain</h3>

<p>If we give each <code>article</code> the <code>contain</code> property with a value of <code>content</code>, when new elements are inserted the browser understands it only needs to recalculate the containing element's subtree, and not anything outside it:</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;h1&gt;My blog&lt;/h1&gt;
&lt;article&gt;
  &lt;h2&gt;Heading of a nice article&lt;/h2&gt;
  &lt;p&gt;Content here.&lt;/p&gt;
  &lt;img src="i-just-showed-up.jpg" alt="social"&gt;
&lt;/article&gt;
&lt;article&gt;
  &lt;h2&gt;Another heading of another article&lt;/h2&gt;
  &lt;img src="graphic.jpg" alt="photo"&gt;
  &lt;p&gt;More content here.&lt;/p&gt;
&lt;/article&gt;</pre>
</div>

<pre class="brush: css notranslate">img {
  float: left;
  border: 3px solid black;
}

article {
  border: 1px solid black;
  contain: content;
}</pre>

<p>This also means that the first image no longer floats down to the second article, and instead stays inside it's containing element's bounds:</p>

<p>{{EmbedGHLiveSample("css-examples/contain/contain-fix.html", '100%', 500)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Containment 2', '#contain-property', 'contain')}}</td>
   <td>{{Spec2('CSS Containment 2')}}</td>
   <td>Added <code>style</code> keyword</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.contain")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Containment">CSS containment</a></li>
 <li>CSS {{cssxref("content-visibility")}} property</li>
 <li>CSS {{cssxref("position")}} property</li>
</ul>
